VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Category"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Klasse Category ('Shop-Kategorie')
' Alfred Ruf 04.05.2011

Private m_Name As String ' BSP: "Zuhause", "Zoohandlung"
Private m_NodeColl As New Collection
Private m_IsEndCategory As Boolean
Private m_IsStartCategory As Boolean
Friend Sub Init(ByVal Name_ As String)
    m_Name = Name_
End Sub
Friend Property Let IsEndCategory(ByVal Bool As Boolean)
    m_IsEndCategory = Bool
End Property
Friend Property Get IsStartCategory() As Boolean
    IsStartCategory = m_IsStartCategory
End Property
Friend Property Let IsStartCategory(ByVal Bool As Boolean)
    m_IsStartCategory = Bool
End Property
Friend Property Get Name() As String
    Name = m_Name
End Property
Friend Function AddNode(ByVal sNodeDef As String, Optional Handled As Boolean) As Boolean
    Dim NOD As New Node
    Dim NOD2 As Node
    
    AddNode = NOD.Init(sNodeDef, Me)
    
    If AddNode Then
        Set NOD2 = NodeItem(NOD.Name)
        If NOD2 Is Nothing Then
            m_NodeColl.Add NOD, NOD.Name
            AddNode = AddGlobNode(NOD)
        Else
            RaiseError "Mehrfache Definition von ""[" & m_Name & "]" & NOD.Name & """"
            AddNode = False
        End If
        Handled = True
    End If
End Function
Friend Sub SearchShortestPaths()
    Dim NOD As Node
    Dim NODS As Node
    Dim MinPathOverall As Single
    
    For Each NOD In m_NodeColl
        NOD.SearchShortestPath
    Next
    
    If m_IsEndCategory Then
        MinPathOverall = c_MaxSingle
        For Each NOD In m_NodeColl
            If NOD.MinPath < MinPathOverall Then
                MinPathOverall = NOD.MinPath
                Set NODS = NOD
            End If
        Next
        
        ' NODS: Endknoten des krzesten Pfades
        NODS.CreatePathInfo
    Else
        ' Festlegung fr Berechung in folgender Kategorie
        Set GL_PrevNodeColl = m_NodeColl
    End If
End Sub
Friend Property Get NodeColl() As Collection
    Set NodeColl = m_NodeColl
End Property
Friend Function NodeItem(ByVal NodeName As String) As Node
    On Error Resume Next
    Set NodeItem = m_NodeColl(NodeName)
End Function
Friend Sub Term()
    Set m_NodeColl = Nothing
End Sub
