VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StopWatch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Klasse StopWatch (Zeitmessung)
' Alfred Ruf 04.05.2011

Private Declare Function QueryPerformanceCounter Lib "kernel32" _
        (lpPerformanceCount As LARGEINT) As Long
                    
Private Declare Function QueryPerformanceFrequency Lib "kernel32" _
        (lpFrequency As LARGEINT) As Long

Private Type LARGEINT
    L_Number As Long
    H_Number As Long
End Type

Private m_Strt As LARGEINT
Private m_Ende As LARGEINT
Private m_Freq As LARGEINT
Private m_Calib As Double
Friend Sub Start()
    QueryPerformanceCounter m_Strt
End Sub
Private Property Get RunTime() As Double
    RunTime = (NumConv(m_Ende) - NumConv(m_Strt)) / NumConv(m_Freq) * 1000 - m_Calib
End Property
Private Sub Halt()
    QueryPerformanceCounter m_Ende
End Sub
Friend Function GetTime() As String
    Halt
    GetTime = Format(RunTime, "0.000") & " ms"
End Function
Private Function NumConv(x As LARGEINT) As Double
    Dim L_Number As Double
    Dim H_Number As Double
    
    L_Number = x.L_Number
    H_Number = x.H_Number
    If L_Number < 0 Then
        L_Number = 4294967296# + L_Number + 1
    End If
    If H_Number < 0 Then
        H_Number = 4294967296# + H_Number + 1
    End If
    NumConv = L_Number + H_Number * 4294967296#
End Function
Private Sub Calibration()
    Start
    Halt
    m_Calib = (NumConv(m_Ende) - NumConv(m_Strt)) / NumConv(m_Freq) * 1000 'ms
End Sub
Private Sub Class_Initialize()
    QueryPerformanceFrequency m_Freq
    Calibration
End Sub


